/****************************************************************************
 *	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	Form1.cs
 *
 *	@brief	DirectSound𗘗pTEho̓vO.
 *
 *	@author	V 閾
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Microsoft.DirectX.DirectSound;
using WaveFile;

namespace sample_0006
{
	public partial class Form1 : Form
	{
		private Device			m_DX       = null;				//!< DirectSoundIuWFNg.
		private SecondaryBuffer	m_DXBuf    = null;				//!< DirectSoundobt@IuWFNg.
		private Notify			m_DXNotify = null;				//!< DirectSoundobt@IuWFNg.
		private string			m_FileName = "";				//!< WAVt@C̃t@C.
		private int				m_BufSize  = 0;					//!< DirectSoundobt@̃TCY.
		private byte[]			m_DataBuf  = null;				//!< WAVt@C̓Ǎݗpobt@.
		private bool			m_IsPlay   = false;				//!< true = Đ / false = ~.
		private bool			m_IsDoing  = false;				//!< true = Đ / false = ~.
		private Thread			m_Thread   = null;				//!< ĐCxgXbhEIuWFNg.
		private AutoResetEvent	m_Event    = null;				//!< ĐCxgEIuWFNg.
		private int				m_WritePos = 0;					//!< Xg[obt@ւWAVEf[^݈ʒu.
		private CWavFile		m_File     = new CWavFile();	//!< WAVt@CEIuWFNg.
		private bool			m_WaveEnd  = false;				//!< true = WAVEf[^I.
		private int				m_EndDelay = 0;					//!< WAVEf[^IĐ~܂ł̃fBC.

		delegate void Delegate_Stop_WaveSound();

		/****************************************************************************/
		/*!
		 *	@brief	RXgN^.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		public Form1()
		{
			InitializeComponent();
		}

		/****************************************************************************/
		/*!
		 *	@brief	_CAȌ.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Form1_Load(object sender, EventArgs e)
		{
			//! foCXR{{bNXDataTableIuWFNg쐬.
			DataTable device_table = new DataTable();
			device_table.Columns.Add("NAME", typeof(string));
			device_table.Columns.Add("GUID", typeof(Guid));

			DevicesCollection	DsEnum = new DevicesCollection();
			DeviceInformation	info;
			int					i;

			//! foCXR{{bNXɃfoCXƑΉGUIDo^.
			for( i = 0; i < DsEnum.Count; i++ ){
				info = DsEnum[i];

				//! 񋓂foCX"vC}EfoCX"̏ꍇAR{{bNXɂ͒ǉȂ.
				if( info.DriverGuid != System.Guid.Empty && info.Description != "" ){
					//! DataTableɃfoCXGIUDǉ.
					DataRow row = device_table.NewRow();
					row["NAME"] = info.Description;
					row["GUID"] = info.DriverGuid;
					device_table.Rows.Add( row );
				}
			}
			DsEnum = null;

			device_table.AcceptChanges();

			//! R{{bNXDataSourceDataTable蓖Ă.
			DeviceList_ComboBox.DataSource    = device_table;
			DeviceList_ComboBox.DisplayMember = "NAME";			// \.
			DeviceList_ComboBox.ValueMember   = "GUID";			// R{{bNX̒l.
		}

		/****************************************************************************/
		/*!
		 *	@brief	_CAȌI.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			//! TEho̓foCXN[Y.
			CloseSoundOutDevice();

			//! WAVt@CN[Y.
			m_File.Close();

			//! WAVt@CEIuWFNgj.
			m_File = null;
		}

		/****************************************************************************/
		/*!
		 *	@brief	ĐWAVt@CI.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void FileSel_Button_Click(object sender, EventArgs e)
		{
			//! TEho͂t@Ct@CI_CAOI.
			if( SelWavFileDialog.ShowDialog( this ) == DialogResult.OK ){
				FileName_TextBox.Text = SelWavFileDialog.FileName;
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	Đ{^Ƃ̏.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Play_Button_Click(object sender, EventArgs e)
		{
			Play_WaveSound();
		}

		/****************************************************************************/
		/*!
		 *	@brief	ꎞ~{^Ƃ̏.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Pause_Button_Click(object sender, EventArgs e)
		{
			Pause_WaveSound();
		}

		/****************************************************************************/
		/*!
		 *	@brief	~{^Ƃ̏.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Stop_Button_Click(object sender, EventArgs e)
		{
			Stop_WaveSound();
		}

		/****************************************************************************/
		/*!
		 *	@brief	ʃ{[o[𑀍삵Ƃ̏.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Volume_Bar_ValueChanged(object sender, EventArgs e)
		{
			Volume_Control();
		}

		/****************************************************************************/
		/*!
		 *	@brief	ʃoXo[𑀍삵Ƃ̏.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Balance_Bar_ValueChanged(object sender, EventArgs e)
		{
			Balance_Control();
		}

		/****************************************************************************/
		/*!
		 *	@brief	WAVt@CĐ.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void Play_WaveSound()
		{
			//! WAVt@CI[vĂȂꍇAI[v.
			if( m_File.IsOpen() == false ){
				//! -1._CAOĐWAVt@C擾.
				m_FileName = FileName_TextBox.Text;

				//! -2.ĐWAVt@CI[v.
				if( m_File.Open( m_FileName ) != true ){
					MessageBox.Show( "t@CI[vł܂", "I[v", MessageBoxButtons.OK );
					return;
				}
			}
			if( m_DX == null ){
				//! WAVt@CI[fBItH[}bg擾.
				WaveFormat wf = new WaveFormat();
				m_File.GetWaveInfo( ref wf );

				//! foCXIXgTEhEfoCXGUID擾.
				System.Guid dev_guid = (System.Guid)DeviceList_ComboBox.SelectedValue;

				//! DirectSoundI[v
				if( OpenSoundOutDevice( dev_guid, wf ) == false ) {
					return;
				}

				//! WAVt@C̓Ǎݗpobt@mۂ.
				m_DataBuf = null;
				m_DataBuf = new Byte[m_BufSize / 2];

				//! ĐJ[\̈ʒu.
				m_DXBuf.SetCurrentPosition( 0 );
				m_WritePos = 0;
			}

			//! TEhĐJn.
			if( m_DXBuf !=  null ){
				m_DXBuf.Play( 0, BufferPlayFlags.Looping );
			}

			//! ĐԂuĐvɂ.
			m_IsPlay = true;

			Play_Button.Enabled         = false;
			Stop_Button.Enabled         = true;
			Pause_Button.Enabled        = true;
			DeviceList_ComboBox.Enabled = false;
			FileName_TextBox.Enabled    = false;
			FileSel_Button.Enabled      = false;
		}

		/****************************************************************************/
		/*!
		 *	@brief	WAVt@C̍Đꎞ~.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void Pause_WaveSound()
		{
			//! ĐԂu~vɂ.
			m_IsPlay = false;

			//! TEhĐ~
			if ( m_DXBuf != null ){
				m_DXBuf.Stop();
			}

			Play_Button.Enabled         = true;
			Stop_Button.Enabled         = true;
			Pause_Button.Enabled        = false;
			DeviceList_ComboBox.Enabled = false;
			FileName_TextBox.Enabled    = false;
			FileSel_Button.Enabled      = false;
		}

		/****************************************************************************/
		/*!
		 *	@brief	WAVt@C̍Đ~.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void Stop_WaveSound()
		{
			//! ĐԂu~vɂ.
			m_IsPlay = false;

			//! TEho̓foCXN[Y.
			CloseSoundOutDevice();

			//! ĐWAVt@CN[Y.
			m_File.Close();

			Play_Button.Enabled         = true;
			Stop_Button.Enabled         = false;
			Pause_Button.Enabled        = false;
			DeviceList_ComboBox.Enabled = true;
			FileName_TextBox.Enabled    = true;
			FileSel_Button.Enabled      = true;
		}

		/****************************************************************************/
		/*!
		 *	@brief	TEho̓foCXI[v.
		 *
		 *	@param	[in]	dev_guid	TEho̓foCXGUID.
		 *	@param	[in]	wf			WAVEtH[}bg\.
		 *
		 *	@retval	true = OK. / false = NG.
		 */
		private bool OpenSoundOutDevice( System.Guid dev_guid, WaveFormat wf )
		{
			try {
				//! DirectSound̍ĐIuWFNg쐬.
				m_DX = new Device( dev_guid );

				//! ĐIuWFNgɑ΂AvP[V̋xݒ肷.
				m_DX.SetCooperativeLevel( this, CooperativeLevel.Priority );

				//! Xg[obt@EIuWFNg쐬.
				BufferDescription desc = new BufferDescription();
				desc.Format      = wf;
				desc.BufferBytes = wf.AverageBytesPerSecond / 4;
				desc.Flags	 	 = BufferDescriptionFlags.GlobalFocus
								 | BufferDescriptionFlags.ControlPositionNotify
								 | BufferDescriptionFlags.ControlVolume
								 | BufferDescriptionFlags.ControlPan;
				m_DXBuf = new SecondaryBuffer( desc, m_DX );
				desc    = null;

				//! mۂꂽXg[obt@̃TCY擾.
				BufferCaps caps;
				caps      = m_DXBuf.Caps;
				m_BufSize = caps.BufferBytes;

				if( m_Thread == null ){
					//! Cxg^XN𐶐.
					m_Thread = new Thread( new System.Threading.ThreadStart( OutputEventTask ) );

					//! ĐCxg̃IuWFNg쐬.
					m_Event = new AutoResetEvent( false );
				}

				//! ĐCxgݒ肷.
				m_DXNotify = new Notify( m_DXBuf );
				BufferPositionNotify[] psa = new BufferPositionNotify[2];
                psa[0].EventNotifyHandle = m_Event.Handle;
				psa[0].Offset            = (m_BufSize / 2) - 1;
				psa[1].EventNotifyHandle = m_Event.Handle;
				psa[1].Offset            = m_BufSize - 1;
				m_DXNotify.SetNotificationPositions( psa, psa.Length );

				//! Cxg^XNN.
				m_IsDoing = true;
				m_Thread.Start();

				return true;
			}
			catch( Exception ex ){
				//! G[bZ[W\.
				MessageBox.Show( ex.Message, "I[v", MessageBoxButtons.OK );

				//! G[ꍇATEho̓foCXN[Y.
				CloseSoundOutDevice();
				return false;
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	TEho̓foCXN[Y.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void CloseSoundOutDevice()
		{
			m_IsPlay  = false;
			m_IsDoing = false;

			//! TEhĐ~.
			if( m_DXBuf != null ){
				m_DXBuf.Stop();
			}

			//! ĐCxgp̃Xbh~.
			if( m_Thread != null ){

				//! _~[ŃCxg𔭍sāAXbhN.
				m_Event.Set();

				//! Xbh~ďł܂ł̊Wait.
				Thread.Sleep( 500 );
			}

			//! 쐬CxgEIuWFNgj.
			m_Event  = null;
			m_Thread = null;

			//! DirectSound̃CxgEIuWFNg.
			if( m_DXNotify != null ){
				m_DXNotify.Dispose();
			}
			m_DXNotify = null;

			//! DirectSound̃obt@EIuWFNg.
			if( m_DXBuf != null ){
				m_DXBuf.Dispose();
			}
			m_DXBuf = null;

			//! DirectSoundIuWFNg.
			if( m_DX != null ){
				m_DX.Dispose();
			}
			m_DX = null;
		}

		/****************************************************************************/
		/*!
		 *	@brief	DirectSound̍ĐCxgʒmR[obN.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void OutputEventTask()
		{
			m_WaveEnd  = false;
			m_EndDelay = 3;

			while( m_IsDoing == true ){

				//! DirectSound̃Cxg܂ő҂.
				m_Event.WaitOne();
				if( m_IsPlay == true ){

					//! WAVt@CǂݍޑOɓǂݍ݃obt@NA.
					System.Array.Clear( m_DataBuf, 0, m_DataBuf.Length );

					//! WAVt@CĐf[^ǂݍ.
					int len = m_File.Read( m_DataBuf );

					if( len == 0 && m_WaveEnd == false ){
						m_WaveEnd  = true;
						m_EndDelay = 3;
					}

					//! Đobt@ɃI[fBIEf[^.
					m_DXBuf.Write( m_WritePos, m_DataBuf, LockFlag.None );

					m_WritePos = m_WritePos + m_DataBuf.Length;
					if( m_WritePos >= m_BufSize ){
						m_WritePos = 0;
					}

					//! ŏIf[^̍ĐÎŁASTOPR}h𔭍s.
					if( m_WaveEnd == true ){
						if( m_EndDelay == 0 ){
							Invoke( new Delegate_Stop_WaveSound( Stop_WaveSound ) );
						}else{
							m_EndDelay = m_EndDelay - 1;
						}
					}
				}
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	ʃ{[ݒύX.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void Volume_Control()
		{
			//! foCXI[vĂȂꍇAoXݒsȂ.
			if( m_DXBuf == null ){
				return;
			}
			//! _CAO{[Rg[̈ʒu擾.
			int range = Volume_Bar.Value;
			int vol   = (int)Volume.Min;
			if( range > 0 && range <= 100 ){
				vol = (int)(1000.0 * Math.Log10( range / 100.0 ));
			}
            if( vol < (int)Volume.Min ) vol = (int)Volume.Min;
			if( vol > (int)Volume.Max ) vol = (int)Volume.Max;

			//! {[ݒύX.
			m_DXBuf.Volume = vol;
		}

		/****************************************************************************/
		/*!
		 *	@brief	ʃoXݒύX.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		private void Balance_Control()
		{
			//! foCXI[vĂȂꍇAoXݒsȂ.
			if( m_DXBuf == null ){
				return;
			}
			//! _CAOoXRg[̈ʒu擾.
			int range   = Balance_Bar.Value;
			int balance = ((50 - range) * ((Pan.Right - Pan.Left) / 2)) / 100;

			//! oXݒύX.
			m_DXBuf.Pan = balance;
		}
	}
}
/* End of File */
